IF (ENABLE_CORBA)

  IF(${CORBA_IMPLEMENTATION} STREQUAL "TAO")
    # Look for TAO and ACE
	find_package(TAO REQUIRED IDL PortableServer CosNaming AnyTypeCode)
    IF(NOT TAO_FOUND)
      MESSAGE(FATAL_ERROR "cannot find TAO")
    ELSE(NOT TAO_FOUND)
      MESSAGE(STATUS "CORBA enabled: TAO")
    ENDIF(NOT TAO_FOUND)

	# Copy flags:
	SET(CORBA_LIBRARIES ${TAO_LIBRARIES})
	SET(CORBA_CFLAGS ${TAO_CPP_FLAGS})
	SET(CORBA_INCLUDE_DIRS ${TAO_INCLUDE_DIR})
	SET(CORBA_DEFINITIONS ${TAO_DEFINITIONS})

  ELSEIF(${CORBA_IMPLEMENTATION} STREQUAL "OMNIORB")
    # Look for OmniORB
    FIND_PACKAGE(OmniORB)
    IF(NOT OMNIORB4_FOUND)
      MESSAGE(FATAL_ERROR "cannot find OmniORB4")
    ELSE(NOT OMNIORB4_FOUND)
      MESSAGE(STATUS "CORBA enabled: OMNIORB")

	  # Copy flags:
	  SET(CORBA_LIBRARIES ${OMNIORB4_LIBRARIES})
	  SET(CORBA_CFLAGS ${OMNIORB4_CPP_FLAGS})
	  SET(CORBA_INCLUDE_DIRS ${OMNIORB4_INCLUDE_DIR})
	  SET(CORBA_DEFINITIONS ${OMNIORB4_DEFINITIONS})

    ENDIF(NOT OMNIORB4_FOUND)

  ELSE(${CORBA_IMPLEMENTATION} STREQUAL "TAO")
    MESSAGE(FATAL_ERROR "Unknown CORBA implementation '${CORBA_IMPLEMENTATION}': must be TAO or OMNIORB.")
  ENDIF(${CORBA_IMPLEMENTATION} STREQUAL "TAO")

ENDIF (ENABLE_CORBA)
