/***************************************************************************
 Copyright (c) 2009 S Roderick <xxxstephen AT theptrgroupxxx DOT comxxx>
                               (remove the x's above)
 ***************************************************************************/

#include <rtt/corba/ControlTaskServer.hpp>
#include <rtt/corba/ControlTaskProxy.hpp>
#include <rtt/RTT.hpp>
#include <rtt/PeriodicActivity.hpp>
#include <rtt/TaskContext.hpp>
#include <rtt/os/main.h>
#include <rtt/Ports.hpp>

#include "../BoostCorbaToolkit.hpp"
#include "../../BoostToolkit.hpp"

// use Boost RTT Toolkit test components
#include "../../tests/recv.hpp"

#include <ocl/TaskBrowser.hpp>

using namespace std;
using namespace Orocos;
using namespace RTT::Corba;


int ORO_main(int argc, char* argv[])
{
    RTT::Toolkit::Import( Examples::BoostToolkit  );
    RTT::Toolkit::Import( Examples::Corba::corbaBoostPlugin  );

	Recv			    recv("Recv");
    PeriodicActivity	recv_activity(
        ORO_SCHED_OTHER, 0, 1.0 / 5, recv.engine());    // 5 Hz

	// Setup Corba and Export:
	ControlTaskServer::InitOrb(argc, argv);
	ControlTaskServer::Create( &recv );
	ControlTaskServer::ThreadOrb();

	// Wait for requests:
	recv.configure();
	recv_activity.start();
    OCL::TaskBrowser tb( &recv );
    tb.loop();
	recv_activity.stop();
      
	// Cleanup Corba:
    ControlTaskServer::ShutdownOrb();
	ControlTaskServer::DestroyOrb();

    return 0;
}
