/***************************************************************************
 Copyright (c) 2009 S Roderick <xxxstephen AT theptrgroupxxx DOT comxxx>
                               (remove the x's above)
 ***************************************************************************/
#include <rtt/corba/ControlTaskServer.hpp>
#include <rtt/corba/ControlTaskProxy.hpp>
#include <rtt/RTT.hpp>
#include <rtt/PeriodicActivity.hpp>
#include <rtt/TaskContext.hpp>
#include <rtt/os/main.h>
#include <rtt/Ports.hpp>
#include <ocl/TaskBrowser.hpp>

#include "../BoostCorbaToolkit.hpp"
#include "../../BoostToolkit.hpp"

// use Boost RTT Toolkit test components
#include "../../tests/send.hpp"

using namespace std;
using namespace Orocos;
using namespace RTT::Corba;

int ORO_main(int argc, char* argv[])
{
    RTT::Toolkit::Import( Examples::BoostToolkit  );
    RTT::Toolkit::Import( Examples::Corba::corbaBoostPlugin  );

	Send				send("Send");
    PeriodicActivity	send_activity(
		ORO_SCHED_OTHER, 0, 1.0 / 10, send.engine());   // 10 Hz

	// start Corba and find the remote task
	ControlTaskProxy::InitOrb(argc, argv);
	ControlTaskServer::ThreadOrb();
	TaskContext* recv = ControlTaskProxy::Create( "Recv" );
	assert(NULL != recv);

	if ( connectPeers( recv, &send ) == false )
	{
		log(Error) << "Could not connect peers !"<<endlog();
	}
	// create data object at recv's side
	if ( connectPorts( recv, &send) == false )
	{
		log(Error) << "Could not connect ports !"<<endlog();
	}

	send.configure();
	send_activity.start();
	log(Info) << "Starting task browser" << endlog();
	OCL::TaskBrowser tb( recv );
	tb.loop();
	send_activity.stop();

	ControlTaskProxy::DestroyOrb();

    return 0;
}

