/***************************************************************************
 Copyright (c) 2009 S Roderick <xxxstephen AT theptrgroupxxx DOT comxxx>
                               (remove the x's above)
 ***************************************************************************/

#include <rtt/RTT.hpp>
#include <rtt/PeriodicActivity.hpp>
#include <rtt/TaskContext.hpp>
#include <rtt/os/main.h>
#include <rtt/Ports.hpp>
#include <ocl/TaskBrowser.hpp>

#include "send.hpp"
#include "recv.hpp"
#include "../BoostToolkit.hpp"

using namespace std;
using namespace Orocos;

int ORO_main(int argc, char* argv[])
{
    // forcibly load the toolkit
    RTT::Toolkit::Import(Examples::BoostToolkit);
	
	Recv		        recv("Recv");
    PeriodicActivity	recv_activity(ORO_SCHED_OTHER, 0, 0.1, recv.engine());
	Send     			send("Send");
    PeriodicActivity	send_activity(ORO_SCHED_OTHER, 0, 0.2, send.engine());

    // connect the two components 
	if ( connectPeers( &send, &recv ) == false )
	{
		log(Error) << "Could not connect peers !"<<endlog();
		return -1;
	}
	if ( connectPorts( &send, &recv) == false )
	{
		log(Error) << "Could not connect ports !"<<endlog();
		return -1;
	}

	send.configure();
	recv.configure();
	send_activity.start();
	recv_activity.start();

    // task browser
    TaskBrowser browser( &recv );
    browser.setColorTheme( TaskBrowser::whitebg );
    browser.loop();

	send_activity.stop();
	recv_activity.stop();

    return 0;
}
