/***************************************************************************
 Copyright (c) 2009 S Roderick <xxxstephen AT theptrgroupxxx DOT comxxx>
                               (remove the x's above)
 ***************************************************************************/
#include "send.hpp"

Send::Send(std::string name) :
		RTT::TaskContext(name),
		ptime_port("ptime"),
		timeDuration_port("timeDuration")
{
	ports()->addPort(&ptime_port);
	ports()->addPort(&timeDuration_port);
}

Send::~Send()
{
}

bool Send::startHook()
{
	// just set last to now
	lastNow			= boost::posix_time::microsec_clock::local_time();
    return true;
}

void Send::updateHook()
{
	boost::posix_time::ptime            now;
    boost::posix_time::time_duration    delta;

	// send the current time, and the duration since the last updateHook()
    now		= boost::posix_time::microsec_clock::local_time();
    delta   = now - lastNow;

    ptime_port.Set(now);
    timeDuration_port.Set(delta);
    
    lastNow = now;
}
